<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY nbsp "&#160;">
]>

<xsl:transform
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
    
    <xsl:output method="xml" indent="yes"/>

    <!--xsl:output encoding="##output-encoding##"/>
    <xsl:output version="##xml-version##"/-->

    <xsl:output encoding="ISO-8859-1"/>
    <xsl:output version="1.0"/>
    <xsl:param name="language" select="'fr'"/>
    <xsl:template match="PESFacture">
        <xsl:processing-instruction name="xml-stylesheet">href="http://projets.admisource.gouv.fr/xemelios/xsl/facture_pes/V1.0/facturePes.xsl" type="text/xsl"</xsl:processing-instruction>
        <PESFacture>
                <xsl:for-each select="./@*">
                    <xsl:attribute name="{local-name(.)}" select="."/>
                </xsl:for-each>
                <xsl:for-each select="./*">
                    <xsl:call-template name="writeElement">
                        <xsl:with-param name="el" select="."/>
                    </xsl:call-template>
                </xsl:for-each>
        </PESFacture>
    </xsl:template>
    
    <xsl:template name="writeElement">
        <xsl:param name="el"/>
        <xsl:element name="{name($el)}">
            <xsl:for-each select="$el/@*">
                <xsl:attribute name="{local-name(.)}" namespace="{namespace-uri(.)}">
                    <xsl:value-of select="."/>
                </xsl:attribute>
            </xsl:for-each>
            <xsl:for-each select="$el/*">
                <xsl:call-template name="writeElement">
                    <xsl:with-param name="el" select="."/>
                </xsl:call-template>
            </xsl:for-each>
            <xsl:value-of select="$el/text()" disable-output-escaping="yes"/>
        </xsl:element>
    </xsl:template>
</xsl:transform>
